﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.Windows.Data;
using System.Globalization;
using Infragistics;
using Infragistics.Controls.Editors;

namespace XamWebComboEditorSample
{
    public class Customer : IProvideDataItems<ComboEditorItem>
    {
        public String FirstName { get; set; }
        public String LastName { get; set; }
        public String Address { get; set; }
        public Boolean IsNew { get; set; }
        public DateTime BirthDay { get; set; }
        public ObservableCollection<CustomerData> Children { get; set; }

        // A null value for IsSubscribed can indicate 
        // "no preference" or "no response".
        public Boolean? IsSubscribed { get; set; }

        public Customer(String firstName, String lastName,
            String address, Boolean isNew, Boolean? isSubscribed)
        {
            this.FirstName = firstName;
            this.LastName = lastName;
            this.Address = address;
            this.IsNew = isNew;
            this.IsSubscribed = isSubscribed;
            this.BirthDay = BirthDay;
            this.Children = new ObservableCollection<CustomerData>();
        }

        public Customer()
        {
        }

        #region IProvideDataItems<ComboEditorItem> Members

        public void AddItem(ComboEditorItem addedObject)
        {
            throw new NotImplementedException();
        }

        public ComboEditorItem CreateItem(object dataItem)
        {
            throw new NotImplementedException();
        }

        public ComboEditorItem CreateItem()
        {
            throw new NotImplementedException();
        }

        public int DataCount
        {
            get { throw new NotImplementedException(); }
        }

        public ComboEditorItem GetDataItem(int index)
        {
            throw new NotImplementedException();
        }

        public void InsertItem(int index, ComboEditorItem insertedObject)
        {
            throw new NotImplementedException();
        }

        public bool RemoveItem(ComboEditorItem removedObject)
        {
            throw new NotImplementedException();
        }

        public void RemoveRange(System.Collections.Generic.IList<ComboEditorItem> itemsToRemove)
        {
            throw new NotImplementedException();
        }

        #endregion
    }

    public class CustomerData
    {
        public String AccountNumber { get; set; }
        public Double Payment { get; set; }
        public Int32 Amount { get; set; }
        public Boolean? IsValid { get; set; }

        public CustomerData(String anumber, Double payment, Int32 amount, Boolean isvalid)
        {
            this.AccountNumber = anumber;
            this.Payment = payment;
            this.Amount = amount;
            this.IsValid = isvalid;
        }

    }

    public class Customers
    {
        ObservableCollection<Customer> _list;
        public ObservableCollection<Customer> CustomerList
        {
            get
            {
                return _list;
            }
        }

        public Customers()
        {
            _list = new ObservableCollection<Customer>();

            _list.Add(new Customer("A.", "Zero",
                "12 North Third Street, Apartment 45",
                false, true));

            _list.Add(new Customer("B.", "One",
                "34 West Fifth Street, Apartment 67",
                false, null));

            _list.Add(new Customer("C.", "Two",
                "56 East Seventh Street, Apartment 89",
                true, false));

            _list.Add(new Customer("D.", "Ehree",
                "78 South Ninth Street, Apartment 10",
                true, true));

            _list.Add(new Customer("E.", "Three",
                "78 South Ninth Street, Apartment 10",
                true, true));

            _list.Add(new Customer("F.", "Three",
                "78 South Ninth Street, Apartment 10",
                true, true));

            _list.Add(new Customer("G.", "Three",
                "78 South Ninth Street, Apartment 10",
                true, true));

            _list[1].Children.Add(new CustomerData("1234", 123.22, 1, true));
            _list[1].Children.Add(new CustomerData("5678", 332, 2, false));
            _list[1].Children.Add(new CustomerData("2345", 11121.00, 2, true));


        }

        public class DateTimeConverter : IValueConverter
        {
            public object Convert(object value,
                               Type targetType,
                               object parameter,
                               CultureInfo culture)
            {
                DateTime date = (DateTime)value;
                return date.ToShortDateString();
            }

            public object ConvertBack(object value,
                                      Type targetType,
                                      object parameter,
                                      CultureInfo culture)
            {
                string strValue = value.ToString();
                DateTime resultDateTime;
                if (DateTime.TryParse(strValue, out resultDateTime))
                {
                    return resultDateTime;
                }
                return value;
            }


        }

    }

    public class SimpleDataRow
    {
        public string TEXT { get; set; }
        public int INT { get; set; }
        public double DBL { get; set; }
        public DateTime TIME { get; set; }
        public bool BOOL { get; set; }

        public SimpleDataRow()
        {
            this.TEXT = "text";
            this.INT = 121212;
            this.DBL = 12.3456;
            this.TIME = DateTime.Now;
            this.BOOL = false;
        }
    }

    public class SimpleData
    {
        ObservableCollection<SimpleDataRow> _rows;
        public ObservableCollection<SimpleDataRow> Rows
        {
            get
            {
                return _rows;
            }
        }

        public SimpleData()
        {
            _rows = new ObservableCollection<SimpleDataRow>();
            _rows.Add(new SimpleDataRow());
            _rows.Add(new SimpleDataRow());
            _rows.Add(new SimpleDataRow());
            _rows.Add(new SimpleDataRow());
            _rows.Add(new SimpleDataRow());
            _rows.Add(new SimpleDataRow());
            _rows.Add(new SimpleDataRow());
        }
    }
}
